#Import Modules
import os, pygame
from pygame.locals import *

from menu import Menu
from scene import Scene

from helper import *

class Game():
    def __init__(self):
    #Initialize Everything
        pygame.init()
        pygame.mixer.init()
        self.screen = pygame.display.set_mode((640, 480))
        pygame.display.set_caption('Death Tower     Cthulhu32  \'07 Pyweek #4')
        pygame.mouse.set_visible(0)

    #Prepare Game Objects
        self.clock = pygame.time.Clock()


    def Run(self):
        # fade from black to our intro
        background = pygame.Surface(self.screen.get_size())
        background.fill((0, 0, 0))
        background.set_alpha(255)

        load_music('introNoise.ogg')
        pygame.mixer.music.play()
        
        intro, null = load_image('cthulhu32logo1.gif')
        fadeCount = 0
        introCount = 0
        
        #Intro Loop
        while 1:
            self.clock.tick(60)

            
        #Handle Input Events
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE:
                        return
                    elif event.key == K_RETURN:
                        fadeCount = 60
                        introCount = 360

            # 1 second fade in
            if fadeCount < 60:
                background.set_alpha(255-fadeCount*8)
                self.screen.blit(intro, (0, 0))
                self.screen.blit(background, (0, 0))
                pygame.display.flip()
                fadeCount = fadeCount + 1
                continue
            elif fadeCount == 60:
                fadeCount = fadeCount + 1
                self.screen.blit(intro, (0, 0))
                pygame.display.flip()
                        
            # 6 second intro totally skippable by user
            if introCount < 360:
                introCount = introCount + 1
            else:
                break

        pygame.mixer.music.stop()

        startMenu = Menu()
        menuImage,null = load_image('titlescreen1.gif')
        startMenu.setMenuBG(menuImage)
        startMenu.setOptions(2)
        startMenu.setCursorOffset((160,207),0)
        startMenu.setCursorOffset((205,325),1)
        
        gameLogic = 0
        #Menu Loop
        while 1:
            self.clock.tick(60)

        #Handle Input Events
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE:
                        return
                    elif event.key == K_DOWN:
                        startMenu.moveDown()
                    elif event.key == K_UP:
                        startMenu.moveUp()
                    elif event.key == K_RETURN:
                        gameLogic = 1 #this should be a menu command

            if gameLogic == 1:
                break
            startMenu.display(self.screen)

        gameScene = Scene()

        #In-Game Loop
        while 1:
            self.clock.tick(60)

            if gameScene.update() == 1:
                return # we quit the gamescene

            gameScene.display(self.screen)
                    
