import os, pygame
from pygame.locals import *

from helper import *

class Level():
    def __init__(self):
        self.groundSurface = 0 # ground surface
        self.tileSurface = 0   # tile surface
        self.roomTitle = ""

    def update(self):
        null = 0

    def draw(self, screen, x,y):
        screen.blit(self.groundSurface, (-x,-y)) #this will be offset in the future
        screen.blit(self.tileSurface, (-x,-y))

    def loadLevel(self, level):
        if level < 10:
            fullname = os.path.join('levels', 'floor0'+str(level)+'.txt')
        else:
            fullname = os.path.join('levels', 'floor'+str(level)+'.txt')
        openLevel = open(fullname, 'r')
        self.roomTitle = openLevel.readline().strip()
        line = openLevel.readline().strip()
        groundData = []
        tileData = []
        itemData = ""
        if line == "Ground":
                #debug
                line = openLevel.readline().strip()
                while line != "Tiles":
                    groundData.append(line)
                    line = openLevel.readline().strip()
                line = openLevel.readline().strip()
                while line != "Items":
                    tileData.append(line)
                    line = openLevel.readline().strip()
                itemData = openLevel.readline().strip()
        openLevel.close()
        # we have acquired level data, now lets put this to use
        levelColumns = len(groundData[0])
        levelRows = len(groundData)
        # make a ground surface
        self.groundSurface = pygame.Surface((levelColumns*32,levelRows*32))
        self.groundSurface.fill((125,125,125))
        # make a tile surface and fill it with transparancy
        self.tileSurface = pygame.Surface((levelColumns*32,levelRows*32))
        self.tileSurface.set_colorkey((0,255,0))
        self.tileSurface.fill((0,255,0))
        # setup tiles to blit
        gtile = []
        gtile0, null = load_image('groundTile0.gif')
        gtile1, null = load_image('groundTile1.gif')
        gtile.append(gtile0)
        gtile.append(gtile1)
        ttile = []
        ttile0, null = load_image('wallTile1.gif')
        ttile.append(ttile0)
        for i in xrange(levelRows):
            curGround = groundData[i]
            curTiles = tileData[i]
            for j in xrange(levelColumns):
                self.groundSurface.blit(gtile[int(curGround[j])],(j*32,i*32))
                if ( curTiles[j] != '0' ):
                    if curTiles[j] == 'W':
                        self.groundSurface.blit(ttile[0],(j*32,i*32))
        # all done! return the max width & height of this level!
        return levelColumns*32, levelRows*32
        
