#Import Modules
import os, pygame
from pygame.locals import *

from player import Player
from level import Level
from helper import *

class Scene():
    def __init__(self):
        self.entityList = []
        self.player = Player()
        self.allsprites = pygame.sprite.RenderPlain((self.player))
        self.currentLevel = Level()
        playerMaxX, playerMaxY = self.currentLevel.loadLevel(0)
        self.player.setMaxX(playerMaxX)
        self.player.setMaxY(playerMaxY)

    def update(self):
        #sprites will update

        for event in pygame.event.get():
            if event.type == QUIT:
                return 1
            elif event.type == KEYDOWN:
                if event.key == K_ESCAPE:
                    return 1
                elif event.key == K_DOWN:
                    self.player.moveB()
                elif event.key == K_RIGHT:
                    self.player.moveR()
                elif event.key == K_UP:
                    self.player.moveT()
                elif event.key == K_LEFT:
                    self.player.moveL()
            elif event.type == KEYUP:
                if event.key == K_DOWN:
                    self.player.stopB()
                elif event.key == K_RIGHT:
                    self.player.stopR()
                elif event.key == K_UP:
                    self.player.stopT()
                elif event.key == K_LEFT:
                    self.player.stopL()
                
        self.allsprites.update()
        return 0 #everything is OK '0'

    def display(self, screen):
        self.currentLevel.draw(screen, int(self.player.getworldX()), int(self.player.getworldY()))
        self.allsprites.draw(screen)
        pygame.display.flip()
